

/*******************************************************************************
 * Instance třídy {@code Zlomek} představují ...
 *
 * @author    jméno autora
 * @version   0.00.000
 */
public class Zlomek
{
//== KONSTANTNÍ ATRIBUTY TŘÍDY =================================================
//== PROMĚNNÉ ATRIBUTY TŘÍDY ===================================================
    private final int CITATEL;
    private final int JMENOVATEL;
//== KONSTANTNÍ ATRIBUTY INSTANCÍ ==============================================
//== PROMĚNNÉ ATRIBUTY INSTANCÍ ================================================
//== PŘÍSTUPOVÉ METODY ATRIBUTŮ TŘÍDY ==========================================
//== OSTATNÍ NESOUKROMÉ METODY TŘÍDY ===========================================

//##############################################################################
//== KONSTRUKTORY A TOVÁRNÍ METODY =============================================

    /***************************************************************************
     *
     */
    public Zlomek()
    {
         this(0,1);
    }
    
    public Zlomek(int citatel)
    {
        this(citatel,1);
    }
    
    public Zlomek(Zlomek z)
    {
        this(z.getCitatel(),z.getJmenovatel());
    }
    
    public Zlomek(int cit, int jm)
    {
        if(jm == 0) {
            cit = 0;
            jm = 1;
        }
        else if(jm < 0) {
            cit *= -1;
            jm *= -1;
        }
        
        int g = gdc(Math.abs(cit),jm);
        

        CITATEL = cit/g;
        JMENOVATEL = jm/g;
    }


//== ABSTRAKTNÍ METODY =========================================================
//== PŘÍSTUPOVÉ METODY INSTANCÍ ================================================
    public int getCitatel() {
        return CITATEL;
    }
  
    public int getJmenovatel() {
        return JMENOVATEL;
    }
    public double toDouble() {
            return (double) getCitatel() / (double) getJmenovatel();
    }
    
    public String toString()
    {
        return String.format("[%s/%s]",getCitatel(),getJmenovatel());
    }
//== OSTATNÍ NESOUKROMÉ  METODY INSTANCÍ =======================================
    public Zlomek pricti(Zlomek z) {
           return new Zlomek(getCitatel()*z.getJmenovatel()+z.getCitatel()*getJmenovatel(),getJmenovatel()*z.getJmenovatel());
    }
    
    public Zlomek pricti(int cit) {
           return pricti(new Zlomek(cit));
    }    
    public Zlomek odecti(Zlomek z) {
           return pricti(z.vynasob(-1));
    }
    
    public Zlomek odecti(int cit) {
           return odecti(new Zlomek(cit));
    }    
    
    public Zlomek vynasob(Zlomek z) {
           return new Zlomek(getCitatel()*z.getCitatel(),getJmenovatel()*z.getJmenovatel());
    }
    
    public Zlomek vynasob(int cit) {
           return vynasob(new Zlomek(cit));
    }
    
    public Zlomek vydel(Zlomek z) {
           if(z.getJmenovatel() == 0) {
               return new Zlomek();
           }
           return new Zlomek(getCitatel()*z.getJmenovatel(),getJmenovatel()*z.getCitatel());
    }
    
    public Zlomek vydel(int cit) {
           return vydel(new Zlomek(cit));
    }
//== SOUKROMÉ A POMOCNÉ METODY TŘÍDY ===========================================
    private static int gdc(int x, int y)
    {
        int pom = 0;
        while(y != 0) {
             pom = y;
             y = x % y;
             x = pom;
            }
       return x;
    }
    
//== SOUKROMÉ A POMOCNÉ METODY INSTANCÍ ========================================
//== VNOŘENÉ A VNITŘNÍ TŘÍDY ===================================================
//== TESTOVACÍ METODY A TŘÍDY ==================================================
//
//     /***************************************************************************
//      * Testovací metoda.
//      */
//     public static void test()
//     {
//          Zlomek instance = new Zlomek();
//     }
//     /** @param args Parametry příkazového řádku - nepoužité. */
//     public static void main( String... args ) { test(); }
}
